//************************************************************************************
//**  
//**  File name:     C:\DEV\ARM_Bootloaders\Source Code HID\Bootloader.c
//**  Generated by:  Flowcode v3.6.11.53
//**  Date:          Wednesday, September 01, 2010 13:47:38
//**  Licence:       Professional
//**  Registered to: Ben Rowland
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_ARM7

//Defines for microcontroller

//Functions
#define MCK 47923200
#include <Cstartup_SAM7_BOOT.c>
#include <arm7io.c>


//Configuration data
#pragma DATA 0x0, 0xff

//Macro function declarations
void FCM_bf();


//Variable declarations
volatile char FCV_RETVAL;
volatile short FCV_COUNTER;
volatile char FCV_SKIP;



//Supplementary defines
void delay_ms(unsigned char count);
void delay_10us(unsigned int count);

#define USCOUNT (MCK / 7500000)
#define US10COUNT (MCK / 800000)

//Macro implementations

void FCM_bf()
{
	
}

//Supplementary implementations
void delay_ms(unsigned char count)
{
	unsigned char i;
	unsigned int loop;

	for(i=0; i<count; i++)
	{
		delay_10us(100);
	}
}

void delay_10us(unsigned int count)
{
	unsigned int i, max = US10COUNT * count;

	for(i=0; i<max; i++);
}

void main()
{
	
	//Initialisation
	AT91F_PIO_CfgInput(AT91C_BASE_PIOA, 0xffffffff);
	AT91C_BASE_PIOA->PIO_IFER = 0xffffffff;
	AT91C_BASE_PIOA->PIO_PPUDR = 0xffffffff;
	AT91C_BASE_TCB->TCB_BMR = 0;
	AT91F_ADC_CfgTimings(AT91C_BASE_ADC, MCKMHz, 4, 50, 2000);


	//Interrupt initialisation code
	
	//C Code
	//C Code:
	char ret = 1;

	FCV_SKIP = 0;

	if((AT91F_RSTGetStatus(AT91C_BASE_RSTC) & AT91C_RSTC_RSTTYP_SOFTWARE) == AT91C_RSTC_RSTTYP_SOFTWARE)
	{
	    FCV_SKIP = 1;
	    
	    while (ret)
	    {

	        ret = AT91F_RSTIsSoftRstActive(AT91C_BASE_RSTC);
	  
	    }
	}



	//Decision
	//Decision: Skip?
	if (FCV_SKIP)
	{
		//C Code
		//C Code:
		
		USB_D_PLUS_PULLUP_OFF();

		asm ("	ldr r15, .bootloaderaddr3 \n \
					b 0x102000 \n \
					.bootloaderaddr3: \n \
					.word 0x102000" );


	} else {
		//Calculation
		//Calculation:
		//  counter = 0
		FCV_COUNTER = 0;
		

		//C Code
		//C Code:
		UsbStart();


		//Loop
		//Loop: While 1
		while (1)
		{
			//Delay
			//Delay: 1 ms
			delay_ms(1);


			//C Code
			//C Code:
			FCV_RETVAL = UsbPoll();



			//Decision
			//Decision: Retval?
			if (FCV_RETVAL)
			{
				//Calculation
				//Calculation:
				//  counter = 0
				FCV_COUNTER = 0;
				

			} else {
				//C Code
				//C Code:
				FCV_RETVAL = get_boot();



				//Decision
				//Decision: Retval?
				if (FCV_RETVAL)
				{
					//Calculation
					//Calculation:
					//  counter = 0
					FCV_COUNTER = 0;
					

				} else {
					//Calculation
					//Calculation:
					//  counter = counter + 1
					FCV_COUNTER = FCV_COUNTER + 1;
					

				}


			}


			//Jump To Program
			//Decision: counter > 3000?
			if (FCV_COUNTER > 3000)
			{
				//C Code
				//C Code:
				
				USB_D_PLUS_PULLUP_OFF();

				asm ("	ldr r15, .bootloaderaddr2 \n \
							b 0x102000 \n \
							.bootloaderaddr2: \n \
							.word 0x102000" );


			}


		}


	}


	mainendloop: goto mainendloop;
}



